#pragma once

#include "ros_bridge/include/JsonMethodes.h"
#include "ros_bridge/include/MessageBaseClass.h"
#include "ros_bridge/include/GenericMessages.h"

#include <QGeoCoordinate>
#include <QObject>


typedef ROSBridge::MessageBaseClass ROSMsg;
typedef ROSBridge::GenericMessages::GeographicMsgs::GeoPoint ROSGeoPoint;
namespace MsgGroups = ROSBridge::MessageGroups;
class GeoPoint : public QObject, public ROSGeoPoint
{
    Q_OBJECT
public:
    typedef MsgGroups::GeoPointGroup Group;

    GeoPoint(QObject *parent = nullptr);
    GeoPoint(double latitude,
               double longitude,
               double altitude,
               QObject *parent = nullptr);
    GeoPoint(const GeoPoint& p,
               QObject *parent = nullptr);
    GeoPoint(const ROSGeoPoint& p,
               QObject *parent = nullptr);
    GeoPoint(const QGeoCoordinate& p,
               QObject *parent = nullptr);

    virtual GeoPoint *Clone() const override;
    GeoPoint &operator=(const GeoPoint&p);
    GeoPoint &operator=(const QGeoCoordinate&p);

};


